/*----------------------------------------------------------------------------
 *
 *								SCSI lib
 *								========
 *
 *		    SCSI  by Kris Kaspersky
 *     ASPI32/SPTI  
 *       CD-R/CD-RW 
 *
 * vesion 0.0	 SEND_SCSI_CMD,
 *				 ASPI-
 *
 * vesion 0.1	      (TEAC, NEC...)
------------------------------------------------------------------------------*/
// BUGFIX LIST
// 1)   - SCSI_BEGIN   SCSI_NEED_SKIP

#ifndef __SCSI_LIB_H__
#define __SCSI_LIB_H__
#include <windows.h>
#include <stdio.h>
#include "SPTI.h"
#include "ASPI32.h"

#ifndef	SCSI_VER
	#define	SCSI_VER	0x0001
#endif

#ifndef SCSI_VER
	#define	SCSI_LIC	"GNU license"
#endif

#ifndef ONE_WAIT						//    
	#define ONE_WAIT	600
#endif

#ifndef MAX_WAIT						// -  
	#define MAX_WAIT	4
#endif

#ifndef	NO_SENSE
	#define NO_SENSE	0
#endif

#ifndef SENSE_SIZE
	#define SENSE_SIZE	((SPTI_MAX_SENSE_SIZE>ASPI_MAX_SENSE_SIZE)?ASPI_MAX_SENSE_SIZE:SPTI_MAX_SENSE_SIZE)
#endif

#ifndef NO_BUF
	#define	NO_BUF		0, 0
#endif

#ifndef ASPI_BUS_SCAN
	#define ASPI_BUS_SCAN	"?.?", 0, 0, 0, 0, 0, 0
#endif

#define	SCSI_NEED_SKIP	0xFF

#define SCSI_DATA_IN			66
#define SCSI_DATA_OUT			99


//=[TRG & LUN]================================================================
//
//		    cd,    ASPI
//
//	ARG:
//		cd		-	   ASPI (   
//					     TRG.LUN)
//
//	RET:
//					  int TRG  LUN  TRG  LUN 
//
//	NOTE:
//		 TRG  LUN      
//  
#ifndef TRG
	#define TRG(cd)		atol(&cd[0])
#endif

#ifndef LUN
	#define LUN(cd)		atol(&cd[2])
#endif

//=[WDV]====================================================================
//
//		:    ,     SPTI
// ( )
//
//	FIXME:
//		not use right
#ifndef isSPTI
	#define isSPTI(cd)	((cd[0]=='\\')?iSPTI : 0)
	#define iSPTI		6
#endif

//=[isASPI]===================================================================
//
//		   CD
//
//	ARG:
//		cd		-	   CD
//
//	RET:
//		== 0		   SPTI
//		== 1		   ASPI
//		>= 2		  
//
//	NOTE:
//		    , ,  
//      "ASPI"  "SPTI"  
//  
#ifndef isASPI
	#define iASPI		9
	#define isASPI(cd)	((cd[1] == '.')?iASPI:0) //&& (TRG(cd) + LUN(cd))) ? iASPI : 0)
#endif



#ifndef getInterface
	#define getInterface(cd)	(isSPTI(cd)?isSPTI(cd):isASPI(cd))
#endif

//=[SEND_SCSI_CMD]============================================================
//
//		   SCSI-   
//      (  
//  SEND_SPTI_CMD  SEND_ASPI_CMD)
//
//	ARG:
//		cd		-	,     
//					 ;
//	
//		CDB		-	CDB ,  
//
//		CDB_sz	-	 CDB-  
//
//		SENSE	-	   SENSE-info   SENSE_SIZE
//
//		buf		-	     
//
//		buf_sz	-	 
//
//		flag	-	 
//
// RET:
//		== SCSI_OK	  
//		!= SCSI_OK	      (. SENSE)
//
SEND_SCSI_CMD(char *cd, char *CDB, int CDB_sz, char *SENSE, unsigned char *buf, int buf_sz, int flag)
{
	int stat;
	int	my_interface;

	//        
	//------------------------------------------------------------------------
	if (cd[0] == '?') { ASPI_SEND_SCSI_INQUITY(0,0); return SCSI_NEED_SKIP; }

	//       
	//------------------------------------------------------------------------
	my_interface = getInterface(cd);

	if (!my_interface && strlen(cd)>2) 
	{
			 ASPI_SEND_SCSI_INQUITY(cd, cd); my_interface = iASPI;
	}

	if (my_interface == iASPI)
	{											//   ASPI

		//    ASPI
		switch(flag)
		{
			case SCSI_DATA_IN:	flag = ASPI_DATA_IN; break;
			case SCSI_DATA_OUT:	flag = ASPI_DATA_OUT; break;
			default:			return -1;
		}

		//      ASPI

		stat = SEND_ASPI_CMD(TRG(cd), LUN(cd), CDB, CDB_sz, SENSE, buf, buf_sz, flag);
		return stat;
	}
	
	if (my_interface == iSPTI)
	{											//   SPTI

		//    SPTI
		switch(flag)
		{
			case SCSI_DATA_IN:	flag = SPTI_DATA_IN; break;
			case SCSI_DATA_OUT:	flag = SPTI_DATA_OUT; break;
			default:			return -1;
		}

		//      SPTI
		stat = SEND_SPTI_CMD(cd, CDB, CDB_sz, SENSE, buf,buf_sz, flag);
		return stat;
	}

	//  
	return 0;
}

//=[ALT]======================================================================
//
//		  
SCSI_SEND_CMD(char *cd, char *CDB, int CDB_sz, char *SENSE, unsigned char *buf, int buf_sz, int flag)
{
	return SEND_SCSI_CMD(cd, CDB, CDB_sz, SENSE, buf, buf_sz, flag);
}

ATAPI_SEND_CMD(char *cd, char *CDB, int CDB_sz, char *SENSE, unsigned char *buf, int buf_sz, int flag)
{
	return SEND_SCSI_CMD(cd, CDB, CDB_sz, SENSE, buf, buf_sz, flag);
}

IDE_SEND_CMD(char *cd, char *CDB, int CDB_sz, char *SENSE, unsigned char *buf, int buf_sz, int flag)
{
	return SEND_SCSI_CMD(cd, CDB, CDB_sz, SENSE, buf, buf_sz, flag);
}

//=[SCSI_IS_READY]============================================================
//
//		   
//
//	ARG:
//		cd		-	 
//	RET:
//		== SCSI_OK	 
//		!= SCSI_OK	  
SCSI_IS_READY(char *cd)
{
	unsigned char CDB[ATAPI_CDB_SIZE]; memset(CDB,0, ATAPI_CDB_SIZE);
	return SEND_SCSI_CMD(cd, (char *)CDB, ATAPI_CDB_SIZE, NO_SENSE, NO_BUF, SCSI_DATA_IN);
}


//=[SCSI_BEGIN]===============================================================
//
//		  
//
//	ARG:
//		cd		-	 
//	RET:
//		== SCSI_OK	 
//		!= SCSI_OK	    
//
//	NOTE:
//		    MAX_WAIT  ONE_WAIT (. )
//
SCSI_BEGIN(char *cd)
{
	int a, status;
	for (a = 0; a < MAX_WAIT; a++)
	{
		status = SCSI_IS_READY(cd);
		if (( status == SCSI_OK) || (status == SCSI_NEED_SKIP)) return status;
		Sleep(ONE_WAIT); if (a) printf("\x7");
	}

	return ~SCSI_OK;
}

#endif //__SCSI_LIB_H__