/*----------------------------------------------------------------------------
 *
 *								SPTI-
 *								============
 *
 *		    SPTI-, 
 *  SEND_SCSI_CMD      SCSI_SEND_CMD,  
 *    SPTI.
 *		 SPTI    Windows NT/2000/XP   
 *   ,     
 *
----------------------------------------------------------------------------*/
#ifndef __KPNC_SPTI_H__
#define __KPNC_SPTI_H__
#include <windows.h>
#include <stdio.h>

//   
//----------------------------------------------------------------------------
#ifndef SCSI_TIME_OUT					//    -
	#define SCSI_TIME_OUT				90000		// ***
#endif

//=[FACK_ERR]=================================================================
//
//		       FACK_ERR(s,x),
//  s -    printf,  x -    
//     
//		  __GUI__,      MessageBox
// (  USER32.lib     ),   
//      (use console mode - console is rulezz!)
//		 ,  FACK_ERR   (  __) 
//  ,       
#ifndef FACK_ERR
	#ifdef __GUI__
		#define FACK_ERR(s,x) MessageBox(0, _NEO_BUF, 0, (sprintf(_NEO_BUF,s,x)&0)|MB_OK);
	#else
		#define FACK_ERR(s,x) fprintf(stderr,"%s %s\n",s, x)
	#endif
#endif


#define SPTI_SCSI_OK					1

#define SCSI_IOCTL_DATA_OUT				0
#define SCSI_IOCTL_DATA_IN				1
#define SCSI_IOCTL_DATA_UNSPECIFIED		2

#define SPTI_DATA_IN					SCSI_IOCTL_DATA_IN
#define SPTI_DATA_OUT					SCSI_IOCTL_DATA_OUT

#define SPTI_SENSE_IN_POS				(sizeof(SCSI_PASS_THROUGH))
#define SPTI_MAX_SENSE_SIZE				0x100		// ***

#define IOCTL_SCSI_PASS_THROUGH_DIRECT	0x4D014		// from ntddscsi.h

typedef struct _SCSI_PASS_THROUGH					// from ntddscsi.h
{
	USHORT	Length;
	UCHAR	ScsiStatus;
	UCHAR	PathId;
	UCHAR	TargetId;
	UCHAR	Lun;
	UCHAR	CdbLength;
	UCHAR	SenseInfoLength;
	UCHAR	DataIn;
	ULONG	DataTransferLength;
	ULONG	TimeOutValue;
	UCHAR*	DataBufferOffset;					// as SCSI_PASS_THROUGH_DIRECT
	ULONG	SenseInfoOffset;
	UCHAR	Cdb[16];
} SCSI_PASS_THROUGH, *PSCSI_PASS_THROUGH;

#ifndef _NEO_BUF
	char _NEO_BUF[0x1000];
#endif


//=[SEND_SPTI_CMD]============================================================
//
//		  SCSI-   SPTI   
//  (  )
//
//	ARG:
//		driver	-	 (, "\\\\.\\X:"  "\\\\.\\CrRom0")
//		CDB		-	  CDB 
//		CDB_sz	-	 CDB   
//		SENSE	-	  SENSE  (0  SENSE-info  )
//		buf		-	  / 
//		buf_sz	-	 
//		flag	-	SCSI_DATA_OUT/SCSI_IOCTL_DATA_IN/SCSI_DATA_UNSPECIFIED
//
//	RET:
//		== SCSI_OK	  
//		!=	SCSI_OK	     (. SENSE)
//
SEND_SPTI_CMD(char *driver, char *CDB, int CDB_sz, char *SENSE, unsigned char *buf, int buf_sz, int flag)
{

	HANDLE					hDevice;
	SCSI_PASS_THROUGH		srb;
	DWORD					status;
	unsigned char			sense_buf[SPTI_SENSE_IN_POS + SPTI_MAX_SENSE_SIZE];
	DWORD					returned;

	// 
	//------------------------------------------------------------------------
	memset(sense_buf, 'U', SPTI_SENSE_IN_POS + SPTI_MAX_SENSE_SIZE);

	if (CDB_sz > 16) {
		fprintf(stderr, "-ERR: invalid SRB_sz\n");		return -1; }

	//  
	//------------------------------------------------------------------------
	hDevice = CreateFile (	driver, GENERIC_READ | GENERIC_WRITE,
							FILE_SHARE_READ | FILE_SHARE_WRITE,
							0, OPEN_EXISTING, 0, 0);

	//  
	//-----------------------------------------------------------------------
	if (hDevice == INVALID_HANDLE_VALUE)
	{
		FACK_ERR("-ERR: open device",driver);
		//fprintf(stderr, "-ERR: open device %s\n",driver); 
		return -1; }

	//  srb
	//------------------------------------------------------------------------
	memset(&srb, 0, sizeof(SCSI_PASS_THROUGH));	// 

	// 
	srb.Length				= sizeof(SCSI_PASS_THROUGH);
	srb.PathId				= 6;					// SCSI controller ID ()
	srb.TargetId			= 6;					// target device ID   ()
	srb.Lun 				= 6;					// logical unit device ID )
	srb.CdbLength			= (unsigned char)CDB_sz;//  CDB 
	srb.SenseInfoLength		= SPTI_MAX_SENSE_SIZE;	//  SenseInfo
	srb.DataIn 				= (unsigned char)flag;	//   
	srb.DataTransferLength	= buf_sz;				//  
	srb.TimeOutValue 		= SCSI_TIME_OUT;		//    TimeOut
	srb.DataBufferOffset	= buf;					//   
	srb.SenseInfoOffset 	= SPTI_SENSE_IN_POS;	//  SENSE  
	memcpy(srb.Cdb, CDB, CDB_sz);					//  CDB

	//  SRB- SCSI/ATAPI-
	status = DeviceIoControl(hDevice, IOCTL_SCSI_PASS_THROUGH_DIRECT,
							&srb, sizeof(SCSI_PASS_THROUGH),
							sense_buf, SPTI_MAX_SENSE_SIZE, &returned, FALSE);

	if (!status) return ~SPTI_SCSI_OK;

	CloseHandle(hDevice);							//  

	//    SENSE_INFO
	//------------------------------------------------------------------------
	if ((returned > SPTI_SENSE_IN_POS) && SENSE)
	{
		memcpy(SENSE, &sense_buf[SPTI_SENSE_IN_POS], SPTI_MAX_SENSE_SIZE);
		return ~SPTI_SCSI_OK;
	}
		return SPTI_SCSI_OK;
		//((SCSI_PASS_THROUGH*)sense_buf)->ScsiStatus
		//  != SCSI_OK     

}




#endif //__KPNC_SPTI_H__